program sigmadelta;
(* Nu met vertragende integratoren! *)
(* Zodanig dat int5 nul moet zijn voor halve schaal. *)
(* Geen fout met extra vertraging. *)

uses Crt;

const
	lengte = 60000;
	overslaan = 3552;
(* aantal monsters dat wordt overgeslagen bij de DFT *)
	c1 = 0.000648018179;
	c2 = 0.010137894357;
	c3 = 0.073366653460;
	c4 = 0.315614906588;
	c5 = 0.807231788708;
	i1 = 1;
	i2 = 1;
	i3 = 1;
	i4 = 1;
	i5 = 1;
	d1 = 0.0001220703125; (* Dip rond 9925,5835257506 Hz *)
	d2 = 0.00048828125; (* Dip rond 19848,7446018647 Hz *)
	pi = 4*arctan(1);
	fsin = 1000/5644800;
	ampl = 0; // 0.0005; (* 0.0005 -> -60 dB DSD *)
	offset = 5000/(0.5*5644800); (* Tonen 5 kHz boven en onder fs/2 -> intermodulatie op 10 kHz *)

	ISI = 0.000001;

(* Coefficienten volgens zcoeff7eordevertragendeint_quasi5eorde_slechteDSD128modulator.xls, *)
(* maar dan uiteraard met de eerste twee overgeslagen, *)
	
var
	xin: extended;
	int1: extended;
	int2: extended;
	int3: extended;
	int4: extended;
	int5: extended;
	int1oud: extended;
	int2oud: extended;
	int3oud: extended;
	int4oud: extended;
	int5oud: extended;
	uit: array[0..lengte] of integer;
	uitvenster: array[0..lengte-overslaan-1] of extended;
	uitvensterISI: array[0..lengte-overslaan-1] of extended;
	ReDFT: array[0..round((lengte-overslaan-1)/2)] of extended;
	ImDFT: array[0..round((lengte-overslaan-1)/2)] of extended;
	ReDFTISI: array[0..round((lengte-overslaan-1)/2)] of extended;
	ImDFTISI: array[0..round((lengte-overslaan-1)/2)] of extended;
	teller: longint;
	freq: longint;
	f: TextFile;
	fdft: TextFile;

begin
	assign(f, './SD5_DSD128vertrintoffsetuit.txt');
	Rewrite(f);
	int1:=0.0006779986543;
	int2:=0;
	int3:=0;
	int4:=0;
	int5:=0.00014553722;
	uit[0]:=1;
	teller:=1;
	while teller<=lengte do
	begin
		xin:=ampl*c1*sin(2*pi*fsin*teller)+c1*offset;
		if int5 > 0 then
			uit[teller]:=1
		else
			uit[teller]:=-1;
		int1oud := int1;
		int2oud := int2;
		int3oud := int3;
		int4oud := int4;
		int5oud := int5;
		int1:=xin-c1*uit[teller]-d1*int2oud+i1*int1oud;
		int2:=int1oud-c2*uit[teller]+i2*int2oud;
		int3:=int2oud-c3*uit[teller]-d2*int4oud+i3*int3oud;
		int4:=int3oud-c4*uit[teller]+i4*int4oud;
		int5:=int4oud-c5*uit[teller]+i5*int5oud;
		writeln(f,uit[teller],' ',teller,' ',int1,' ',int2,' ',int3,' ',int4,' ',int5);
		teller:=teller+1;
	end;
	close(f);
	assign(fdft, './SD5_DSD128vertrintoffsetspectrum.txt');
	Rewrite(fdft);
	for teller:=0 to lengte-overslaan-1 do
	begin
		uitvenster[teller]:=uit[teller+overslaan+1]*(1-cos(2*pi*teller/(lengte-overslaan)));
		uitvensterISI[teller]:=uit[teller+overslaan+1]*(1+ISI*uit[teller+overslaan])*(1-cos(2*pi*teller/(lengte-overslaan)));
	end;
	for freq:=0 to round((lengte-overslaan-1)/2) do
	begin
		ReDFT[freq]:=0;
		ImDFT[freq]:=0;
		ReDFTISI[freq]:=0;
		ImDFTISI[freq]:=0;
		for teller:=0 to lengte-overslaan-1 do
		begin
			ReDFT[freq]:=ReDFT[freq]+cos(2*pi*freq*teller/(lengte-overslaan))*uitvenster[teller]/(lengte-overslaan-1);
			ImDFT[freq]:=ImDFT[freq]+sin(2*pi*freq*teller/(lengte-overslaan))*uitvenster[teller]/(lengte-overslaan-1);
			ReDFTISI[freq]:=ReDFTISI[freq]+cos(2*pi*freq*teller/(lengte-overslaan))*uitvensterISI[teller]/(lengte-overslaan-1);
			ImDFTISI[freq]:=ImDFTISI[freq]+sin(2*pi*freq*teller/(lengte-overslaan))*uitvensterISI[teller]/(lengte-overslaan-1);
		end;
		writeln(fdft,freq,' ',ReDFT[freq],' ',ImDFT[freq],' ',10*ln(ReDFT[freq]*ReDFT[freq]+ImDFT[freq]*ImDFT[freq])/ln(10)+20*ln(4)/ln(10),' ',10*ln(ReDFTISI[freq]*ReDFTISI[freq]+ImDFTISI[freq]*ImDFTISI[freq])/ln(10)+20*ln(4)/ln(10));
	end;
	close(fdft);
end.
